import java.lang.*;
import java.util.*;

public class PickIt {

  public PickIt() {
  }

   // from among the packages we carry find the best destination
  public static ICFPPack FindClosestDestination( ) {

     // Coords  pick = new  Coords(0,0 );
     ICFPPack picked= null;
     Hashtable myInventory = Player.myInventory();
	 if ( myInventory == null ) return null;
     Coords  us = Player.getCurrentLocation();
     Coords dist = new Coords ( 0, 0 );
     int len = 0;
     for ( Enumeration ePacks = myInventory.elements(); ePacks.hasMoreElements(); ) {
       ICFPPack p = (ICFPPack) ePacks.nextElement();
       Coords p_to = p.getDest();
/* looking only at the distance, not the path
            int  p_dist_x = Math.abs( p_to.x - us.x) ;
            int  p_dist_y = Math.abs( p_to.y - us.y);
            if (( p_dist_x + p_dist_y ) < (dist.x + dist.y ))    {
                 dist.x = Math.abs( p_to.x - us.x );
                 dist.y = Math.abs( p_to.y - us.y );
                 picked = p;
           }
*/
       Vector pathTo = Path.getPathTo(us.x, us.y, p_to.x, p_to.y );
       if ( pathTo.size() == 0 ) continue;
       if ( (len ==0) || ( pathTo.size() < len )) {
          len = pathTo.size();
          picked = p;
       }

    }
    return picked;
  }

  // find the closest package to pick up.
  public static ICFPPack FindClosestPackage(  boolean useCertain )
  {
     Coords  pick = new  Coords(0,0 );
     ICFPPack picked= null;
     int len = 0;
     Hashtable packages = ICFPContest.getAllKnownPackages();
     Coords  us = Player.currLoc;
     Coords dist = new Coords ( 0, 0 );
     for(Enumeration ePacks=packages.elements(); ePacks.hasMoreElements(); ) {
       ICFPPack p = (ICFPPack)ePacks.nextElement();
	   ICFPContest.log(" testing package #"+p.getID()+" which is going to "+p.getLoc(),5);
       Coords p_to = p.getLoc();
       if ( useCertain && !p.locCertain() )  {
			ICFPContest.log("  but it's location is uncertain so we're skipping it..",5);
		   continue;
	   }
/*
            int  p_dist_x = Math.abs( p_loc.x - us.x) ;
            int  p_dist_y = Math.abs( p_loc.y - us.y);
            if (( p_dist_x + p_dist_y ) < (dist.x + dist.y ))   {
                 dist.x = Math.abs( p_loc.x - us.x );
                 dist.y = Math.abs( p_loc.y - us.y );
                 picked = p;
           }
*/
       Vector pathTo = Path.getPathTo(us.x, us.y, p_to.x, p_to.y );
       if (pathTo.size() == 0 ) continue;
       if ( (len ==0) || ( pathTo.size() < len )) {
          len = pathTo.size();
          picked = p;
       }
    }
    return picked;
  }
  // given a hash list of packages at our location, decide which ones to pick up
  // based on value & distance vs the ones we are currently carrying
  public static Vector selectPackages( Hashtable packages )
  {
    int capacity =  Player.carryingCapacity;
    int carried = 0;
    int atloc = 0;
    int allow = 0;
    Vector pickList = new Vector();
    Hashtable mine = Player.myInventory();


    for (Enumeration em = mine.elements(); em.hasMoreElements(); ) {
      ICFPPack pack = (ICFPPack) em.nextElement();
      carried += pack.getWeight();
    }
    // for now if we're carrying all that we can, just go
    if ( carried == capacity ) return null;

    for (Enumeration ep_loc= packages.elements(); ep_loc.hasMoreElements();) {
        ICFPPack here = (ICFPPack) ep_loc.nextElement();
        atloc += here.getWeight();
    }
    if ( carried + atloc < capacity ) { // get them all
        for (Enumeration ep_loc=packages.elements(); ep_loc.hasMoreElements();) {
            ICFPPack here = (ICFPPack) ep_loc.nextElement();
            pickList.addElement(  here.getID().toString() );
        }
    } else { // for first cut just pick up what we can carry
        allow = capacity - carried;
        for ( Enumeration ep_loc=packages.elements(); ep_loc.hasMoreElements();) {
           ICFPPack pack =(ICFPPack) ep_loc.nextElement();
           if ( pack.getWeight() < allow ) {
               pickList.addElement( (String) pack.getID().toString());
               allow -= pack.getWeight();
           }
        }
     }
     return pickList;
  }

  public static Coords findNearestPickup()
  {
      Coords me = Player.currLoc;
      int dx = 1;
      int dy = 1;
      Coords spot = me;
      for ( dx = 1; dx < ICFPContest.mapWidth; dx++ ) {
         for ( dy = 1; dy < ICFPContest.mapHeight; dy++ ) {
            if ( spot.x+dx  < ICFPContest.mapWidth ) {
              if ( spot.y+dy < ICFPContest.mapHeight ) {
                  if ( ICFPContest.mapData[spot.x+dx][spot.y+dy] == '@' )
                          return new Coords( spot.x+dx, spot.y+dy );
              }
              if ( spot.y-dy > 0 ) {
                  if ( ICFPContest.mapData[spot.x+dx][spot.y-dy] == '@' )
                     return new Coords( spot.x+dx, spot.y-dy ) ;
              }
            }
            if ( spot.x-dx > 0 ) {
              if ( spot.y+dy < ICFPContest.mapHeight ) {
                  if ( ICFPContest.mapData[spot.x-dx][spot.y+dy] == '@' )
                      return new Coords( spot.x-dx, spot.y+dy );
              }
              if ( spot.y-dy > 0 ) {
                  if ( ICFPContest.mapData[spot.x-dx][spot.y-dy] == '@' )
                     return new Coords( spot.x-dx, spot.y-dy ) ;
              }
           } //
        } // for all dy
     }  //for all dx
     return null; // no find
 }

  public static void skipDest( Coords dest ) {
	  // XXX implement list of undesireable coordinates.

  }


}
