/* Static class to encapsulate the Player state */

import java.lang.*;
import java.util.*;

public class Player {
	public static Coords currLoc;
	public static int balance = -1;
	public static int carryingCapacity;
	public static int startingBalance;
	public static int capacity;

	public static int score = 0;
	
	public static Integer robotID;

	public static Hashtable inventory;

	private static Coords currDest = null;
	private static Vector currPath = null;

	// Hackish, but good for testing...
	// public static boolean lastTurnPickup = false;

	// Stupid 
	private static String currDir = "N";

	public static Move getMove() {
		Move move = new Move();
		boolean moveDone = false;
		int turncount = 0;

		// First cehck for something to drop.

		Vector packs = null;
MOVE:	if ( ( packs = packagesToDropHere() ) != null )
		{
			ICFPContest.log( "Dropping "+packs.size()+" packages",4);
			ICFPContest.log( " Packlist is "+packs.toString(), 5);
			move.setDropList(packs);
			if( ICFPContest.robotCount > 1) move.setBid(10);
			currDest = null;
			moveDone = true;
			break MOVE;
		} else if ( ( packs = packagesToPickupHere() ) != null ) {
			ICFPContest.log( "Picking up "+packs.size()+" packages",4);
			move.setPickList(packs); 
			if( ICFPContest.robotCount > 1) move.setBid(10);
			currDest = null;
			moveDone = true;
			break MOVE;
		} else {
			//  Stupid maze following algorithm doesn't really work..
			//turnLeft();
			//while ( !moveDone && turncount < 5) {
			//	if( canMove( currDir ) ) {
			//		move.setDirection( currDir );
			//		moveDone = true;
			//	} else {
			//		turnRight(); turncount++;
			//	}
			//}

DEST: 		do {
				if ( currDest == null  || currLoc.equals( currDest ) ) {
					currDest = pickDest();
					ICFPContest.log("Picked new destination of " + currDest.toString(), 4);
					currPath = null;  // New Dest requires new path
				}

				if ( currPath == null ) {
					ICFPContest.log("Calculating new path to "+currDest.toString(), 4);
					currPath = Path.getPathTo( currLoc, currDest );
					if ( currPath == null ) {
						PickIt.skipDest( currDest );
						ICFPContest.log("Can't find a path!", 4);
						currDest = null; // We can't get there, so pick a new dest
						continue DEST;
					}
					ICFPContest.log("New path has " + currPath.size() + " Steps",4);
				}


				// Then follow the path.
				Coords nextStep = (Coords) currPath.firstElement();
				while ( nextStep.equals( currLoc ) ) {
					currPath.removeElementAt(0);
					if (currPath.size() == 0) { 
						currPath = null;
						continue DEST;
					}
					nextStep = (Coords) currPath.firstElement();
				}

				if ( currLoc.distFrom( nextStep ) > 1 )
				{
					ICFPContest.log ( "Current Path doesn't give next step, recalculating", 4);
					Vector newPath = Path.getPathTo( currLoc, nextStep );
					for ( 	Enumeration oldPath = currPath.elements();
							oldPath.hasMoreElements(); )
					{
						newPath.addElement(oldPath.nextElement());
					}
					currPath = newPath;
					nextStep = (Coords) currPath.firstElement();
				}

				ICFPContest.log("I'm at "+currLoc+" want want to go to "+nextStep+" which is "+currLoc.directionTo( nextStep ), 5);

				move.setDirection( currLoc.directionTo( nextStep ) );
				moveDone = true;
				break DEST;
			} while ( ! moveDone );

		}

		if ( ! moveDone ) {
			// do a no-op
			move.addToPickList(new Integer(0));
			ICFPContest.log("Can't move", 3 );
		}

		if ( balance > 0 && Math.abs( move.getBid() ) > balance ) {
			int sign = 1;
			if ( move.getBid() < 0) sign = -1;

			move.setBid( sign * balance );
		}

		balance -= Math.abs( move.getBid() );

		ICFPContest.log("bid of: "+move.getBid()+" money remainting: "+balance,3);
		if ( balance <= 0 ) ICFPContest.log("You're out of money!",1);
		return move;
	}

	private static Coords pickDest() {
		// First check to see if we have something to drop off.
		Coords dest = null;

		ICFPPack destPack = null;

		ICFPContest.log("Finding closest package dest... ", 4);
		destPack = PickIt.FindClosestDestination();

		if ( destPack != null ) 
		{
			ICFPContest.log("   taking package #" + destPack.getID() + " to "+destPack.getDest(), 4);
			return destPack.getDest();
		} else {
			ICFPContest.log("   nada..",4);
		}

		ICFPContest.log("Finding a package nearby...",4);
		destPack = PickIt.FindClosestPackage( true );
		if ( destPack != null) {

			ICFPContest.log("  Going to pick up package #" + destPack.getID()+" at "+destPack.getLoc(), 4);
			return destPack.getLoc();
		} else if ( (dest = PickIt.findNearestPickup()) != null) {
			ICFPContest.log("Going to home base",4);
			return dest;
		} else {
			ICFPContest.log("Doing wall folling algorithm",4);
			dest = new Coords(currLoc);
			int turnCount = 0;
			turnLeft();
			while ( turnCount < 5 ) {
				if( canMove( currDir ) ) {
					dest.move( currDir );
					break;
				} else {
					turnRight(); turnCount++;
				}
			}
		}
		
		return dest;

	}

	private static Vector packagesToDropHere() {
		Vector dropList = new Vector();
		int packageCount = 0;

		Hashtable inv = myInventory();
		if ( inv == null ) return null; // I'm not carrying anything

		for (	Enumeration packs = inv.elements();
				packs.hasMoreElements(); ) {
			ICFPPack pack = (ICFPPack) packs.nextElement();
			if ( pack.getDest().equals( currLoc ) ) {
				// Add package to drop list 
				dropList.addElement( pack.getID() );
				packageCount++;
			}
		}

		if ( packageCount > 0 ) 
			return dropList;
		else 
			return null;
	}

	private static Vector packagesToPickupHere() {
		Vector pickList = new Vector();
		int packageCount = 0;
		int remCapacity = capacity;

		Hashtable here = ICFPContest.getPackagesHere();
		if ( here == null ) return null; // Nothing here.

		for ( 	Enumeration packs = here.elements();
				packs.hasMoreElements(); ) {
			ICFPPack pack = (ICFPPack) packs.nextElement();
			if ( pack.getWeight() <= remCapacity ) {
				pickList.addElement( pack.getID() );
				packageCount++;
				remCapacity -= pack.getWeight();
			}
		}

		if ( packageCount > 0 ) 
			return pickList;
		else 
			return null;
	}

	private static boolean canMove (String dir) {
		Coords dest = new Coords( currLoc );
		boolean answer = true;

		dest.move( dir );

		switch ( ICFPContest.mapData[dest.x][dest.y] ) {
			case '#':
			case '~':
				answer = false;
		}

		return answer;
	}

	private static void turnRight() {
		switch ( currDir.charAt(0) ) {
			case 'N':
				currDir = "E";
				break;
			case 'E':
				currDir = "S";
				break;
			case 'S':
				currDir = "W";
				break;
			case 'W':
				currDir = "N";
				break;
		}
	}

	private static void turnLeft() {
		switch ( currDir.charAt(0) ) {
			case 'N':
				currDir = "W";
				break;
			case 'E':
				currDir = "N";
				break;
			case 'S':
				currDir = "E";
				break;
			case 'W':
				currDir = "S";
				break;
		}
	}

	public static Hashtable myInventory() {
		return ICFPContest.getRobotInventory( Player.robotID );
	}

	public static Coords getCurrentLocation() {
		return currLoc;
	}
}
